MOP                         ! LENGTH = 365 bytes
<< -> a o <<                ! store array and operation in local variables
  DEPTH DUPN                ! double stack
  DEPTH 2 / ->LIST          ! copy stack into a list
  a IFERR RCL               ! if array is a name (stored in an object)
  SWAP OVER a 3 ->LIST      ! then add name and contence of object to the list
  THEN + a a ROT END        ! else add array to the list
  -> b <<                   ! store list (backup in case of an error)
  1 SWAP SIZE LIST->        ! size of array
  IF 1 - THEN * END         ! if it is a 2-dim array then multiply size of
                            ! row and column
  IFERR                     ! start errortrapping for forbidden operation
    FOR i                   ! loop for do the operation on every element
      IF a TYPE 6 ==        ! if array is a name (stored in an object)
      THEN a END            ! put array-name in stack
      i OVER i GET          ! get next array-element
      'X' STO               ! store it
      o EVAL                ! do the operation on that element
      IFERR                 ! if result is a complex number and array
        PUT THEN            ! contains only real numbers (==>error)
        ROT (1,0) *         ! convert array into a complex array
        ROT ROT PUT         ! and store the modified element once again
      END
    NEXT
  THEN                      ! if there was a forbidden operation (like INV(0))
    CLEAR                   ! delete data-garbage (from the error)
    b LIST-> DROP           ! recall backup
    IF a TYPE 6 == THEN STO ! if array was a name then restore it
    LIST-> DROP END         ! and recall old stack
    "MOP Error:             ! text for error-display
"                           ! important line feed !!
    ERRM + 1 DISP           ! add error-message and show it
  END
  'X' PURGE                 ! delete no more longer used variable
  >> >>
>>

//////////////////////////////////////////////////////////////////////////// 
 
A second, tiny version of MOP, in which the array must be directly in the
stack; only call by value is possible (like in example 1 above):
 
 
MOP                         ! LENGTH = 260.5 bytes
<< -> a o <<                ! store array and operation in local variables
  DEPTH DUPN                ! double stack
  DEPTH 2 / ->LIST          ! copy stack into a list
  a +                       ! add array to the list
  -> b <<                   ! store list (backup in case of an error)
  a 1 SWAP SIZE LIST->      ! size of array
  IF 1 - THEN * END         ! if it is a 2-dim array then multiply size of
                            ! row and column
  IFERR                     ! start errortrapping for forbidden operation
    FOR i                   ! loop for do the operation on every element
      IF a TYPE 6 ==        ! if array is a name (stored in an object)
      THEN a END            ! put array-name in stack
      i OVER i GET          ! get next array-element
      'X' STO               ! store it
      o EVAL                ! do the operation on that element
      IFERR                 ! if result is a complex number and array
        PUT THEN            ! contains only real numbers (==>error)
        ROT (1,0) *         ! convert array into a complex array
        ROT ROT PUT         ! and store the modified element once again
      END
    NEXT
  THEN                      ! if there was a forbidden operation (like INV(0))
    CLEAR                   ! delete data-garbage (from the error)
    b LIST-> DROP           ! recall backup
    "MOP Error:             ! text for error-display
"                           ! important line feed !!
    ERRM + 1 DISP           ! add error-message and show it
  END
  'X' PURGE                 ! delete no more longer used variable
  >> >>
>>
